//Browser.java

import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;
import javax.swing.text.*;
import javax.swing.text.html.*;
import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.io.*;

class Browser extends JFrame {
	private JEditorPane jt;
	private JButton close;
	private final JFrame f;
	
	
	Browser(URL codebase, String seite){
		f = this;
		try {
           	URL url = null;
			try {
				url = new URL(codebase , seite);
            } catch (java.net.MalformedURLException exc) {
                   System.err.println("Attempted to open "+seite
                                      + "with a bad URL: " + url);
                   url = null;
            }
            
            if(url != null) {
            	menuBar.registerFrame(this);
            	jt = new JEditorPane(url);
                jt.setEditable(false);
               	jt.addHyperlinkListener(new Browser_HyperlinkListener());
                JScrollPane scroller = new JScrollPane();
                Border b = BorderFactory.createCompoundBorder(BorderFactory.createEmptyBorder(12, 12, 2, 12), 
                		   BorderFactory.createEtchedBorder());
                scroller.setBorder(b);
                scroller.add(jt);
                JViewport vp = scroller.getViewport();
                vp.add(jt);
                vp.setBackingStoreEnabled(true);
                close = new JButton("Close window");
                close.addActionListener(new ActionListener(){
                	public void actionPerformed(ActionEvent ae){
                		dispose();
                	}
                });
                JPanel p_close = new JPanel();
                p_close.setLayout(new FlowLayout(FlowLayout.RIGHT));
                p_close.add(close);
                p_close.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 6));
                Container c = getContentPane();
                c.add(scroller, BorderLayout.CENTER);
                c.add(p_close, BorderLayout.SOUTH);
            }
	} catch (MalformedURLException e) {
	    System.err.println("Malformed URL: " + e);
	} catch (IOException e) {
	    System.err.println("IOException: " + e);
	}
}

	public void setPage(final URL codebase, final String seite){
		SwingUtilities.invokeLater(new Runnable(){
					public void run(){
						//Original sichern
						Document doc = jt.getDocument();
						try{
							URL url = new URL(codebase, seite);
							jt.setPage(url);
						} catch (IOException io){
							JOptionPane.showMessageDialog(Browser.this, "Can't follow link", "Invalid Input", JOptionPane.ERROR_MESSAGE);
							jt.setDocument(doc);
						}
					}
				});
	}
	
	class Browser_HyperlinkListener implements HyperlinkListener{
		public void hyperlinkUpdate(final HyperlinkEvent e){
			if (e.getEventType() == HyperlinkEvent.EventType.ACTIVATED) {
				SwingUtilities.invokeLater(new Runnable(){
					public void run(){
						//Original sichern
						Document doc = jt.getDocument();
						try{
							URL url = e.getURL();
							jt.setPage(url);
						} catch (IOException io){
							JOptionPane.showMessageDialog(Browser.this, "Can't follow link", "Invalid Input", JOptionPane.ERROR_MESSAGE);
							jt.setDocument(doc);
						}
					}
				});
			}
		}
	}
} // end of class browser