// DiffGrayscalePanel.java

import javax.swing.*;
import javax.swing.border.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.Color.*;

class DiffGrayscalePanel extends JPanel
{
	int[][] grayscalesample1 = {{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0},
				   {0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0}},
		grayscalesample2 = {{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0},
				   {0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0}};				   
				   
	Dimension panelsize;
	int panelwidth;
	int panelheight;				   
	double[] dx = new double[8];
	double[] dy = new double[8];
	int tilesizex, tilesizey;
	
	Insets insets;
	
	DiffGrayscalePanel()
	{}
	
	DiffGrayscalePanel(String title)
	{
		setBorder(new TitledBorder(title));
		setToolTipText("RED - target smaler than approx.             BLUE - target higher than approx.");
		
	} // end of constructor
	
	public void updateMe(int[][] grayscalesample1, int[][] grayscalesample2)
	{
		this.grayscalesample1=grayscalesample1;
		this.grayscalesample2=grayscalesample2;
		repaint();
	}
	
	
	public void paintComponent(Graphics g)
	{			
		panelsize = getSize();
		panelwidth = panelsize.width;
		panelheight = panelsize.height;
				
		insets = new Insets(0,0,0,0); // falls mal nachgebessert werden muss, warum auch immer ...
						
		super.paintComponent(g);
		
		
		tilesizex = Math.round( (panelwidth-insets.left-insets.right)/8 );
		tilesizey = Math.round( (panelheight-insets.top-insets.bottom)/8 ) +3;
				
		for (int x = 0; x < 8; x++)
		{
			dx[x] = Math.round((panelwidth-insets.left-insets.right)/8*x);
			for (int y = 0; y < 8; y++)			
			{
				int color = 0;
				Color c;
				
				dy[y] = Math.round((panelheight-insets.top-insets.bottom)/8*y);
			
				if (grayscalesample1[y][x] >= grayscalesample2[y][x])
				{
					color = grayscalesample1[y][x] - grayscalesample2[y][x];
					if (color > 255) color = 255;
					else if (color < 0) color = 0;
					c = new Color(0,0,color);
				}
				else 
				{
					color = grayscalesample2[y][x] - grayscalesample1[y][x];
					if (color > 255) color = 255;
					else if (color < 0) color = 0;
					c = new Color(color,0,0);				
				}			
				g.setColor(c);
				g.fillRect((int)dx[x]+insets.left,(int)dy[y]+insets.top,tilesizex,tilesizey);					
			} // end of for y ...	
		}// end of for x ...			
	} // end of public void paintComponent( ... )	
} // end of class GrayscalePanel extends JPanel
