// GrayscalePanel.java

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.Color.*;

class GrayscalePanel extends JPanel
{
	int[][] grayscalesample = {{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0},
				   {0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0}};
				   
	Dimension panelsize;
	int panelwidth;
	int panelheight;				   
	double[] dx = new double[8];
	double[] dy = new double[8];
	int tilesizex, tilesizey;
	
	Insets insets;
	
	GrayscalePanel()
	{}
	
	GrayscalePanel(String title)
	{
		setBorder(m.titledborder(title));
		
	} // end of constructor
	
	public void updateMe(int[][] grayscalesample)
	{
		this.grayscalesample=grayscalesample;
		repaint();
	}
	
	
	public void paintComponent(Graphics g)
	{			
		String s;
		
		int color;
				
		panelsize = getSize();
		panelwidth = panelsize.width;
		panelheight = panelsize.height;
				
		insets = new Insets(0,0,0,0);
						
		super.paintComponent(g);
						
		tilesizex = Math.round( panelwidth/8 );
		tilesizey = Math.round( panelheight/8 )+3;
				
		for (int x = 0; x < 8; x++)
		{		
			dx[x] = Math.round(panelwidth/8*x);
			for (int y = 0; y < 8; y++)
			{		
				dy[y] = Math.round(panelheight/8*y);
				if (grayscalesample[y][x] > 255) 
				{ color = 255; }
				else if (grayscalesample[y][x] < 0) 
				     { color = 0; }
				     else {color = grayscalesample[y][x];}
						
				g.setColor(new Color(color,color,color));			
				g.fillRect((int)dx[x],(int)dy[y],tilesizex,tilesizey);		
			} // end of for y ...	
		}				
	} // end of public void paintComponent( ... )		
} // end of class GrayscalePanel extends JPanel
