// NumericPanel.java

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.Color.*;

class NumericPanel extends JPanel
{
	int[][] grayscalesample = {{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0},
				   {0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0}};
	Dimension panelsize;
	int panelwidth;
	int panelheight;				   
	double[] dx = new double[8];
	double[] dy = new double[8];	
		
	Font font = new Font("Serif",Font.PLAIN,9);
	
	NumericPanel()
	{}
	
	NumericPanel(String title)
	{
		setBorder(m.titledborder(title));		
	} // end of constructor
	
	public void updateMe(int[][] grayscalesample)
	{
		this.grayscalesample=grayscalesample;
		repaint();
	}
	
	public void paintComponent(Graphics g)
	{					
		panelsize = getSize();
		panelwidth = panelsize.width;
		panelheight = panelsize.height;
						
		super.paintComponent(g);
		
		g.setFont(font);
						
		for (int y = 0; y < 8; y++)
		{
			dy[y] = Math.round((panelheight/8-0)*y); // -0 was -3
			for (int x = 0; x < 8; x++)
			{
				dx[x] = Math.round(panelwidth/8*x);
				int dummy = grayscalesample[y][x];
			
				if (dummy <= 0) dummy = 0;
				else if (dummy > 255) dummy = 255;
				else if (dummy == 0) dummy = 0;
				String s = String.valueOf(dummy);
				if (s.length() == 1) { s="  "+s;}
				else if (s.length() == 2) { s=" "+s;}
				g.drawString(s,(int)dx[x]+5,(int)dy[y]+16); // ...+25);		
			}
		}
	} // end of public void paintComponent( ... )	
} // end of class NumericPanel extends JPanel
