// QuantizeDialog.java

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;

class QuantizeDialog extends JDialog
{
	Toolkit tk = Toolkit.getDefaultToolkit();
	Dimension screenDim = tk.getScreenSize();
	
	QuantizeDialog(JFrame parent, int quantizeMode)
	{
		super(parent, "The used quantize table",true);
		
		int tmpi = 1;
								
		JPanel p1 = new JPanel(new GridLayout(8,8)),
		       p2 = new JPanel();
		
		JLabel l[][] = new JLabel[8][8];
		JButton b = new JButton("Close");
		
		b.addActionListener(
		new ActionListener() { public void actionPerformed(ActionEvent e) { dispose(); } });
				
		if (quantizeMode == 6) // JPEG Standard Table
		{ 			
			for (int u=0; u<=7; u++)
			for (int v=0; v<=7; v++)
			{
				l[u][v] = new JLabel(String.valueOf(m.StandardJPEGTable[u][v]),SwingConstants.CENTER);
				l[u][v].setBorder(new SoftBevelBorder(BevelBorder.LOWERED));
				p1.add(l[u][v]);
			}
			
		} // end of if
		else 
		{	
			switch (quantizeMode)
			{	// quantize table with only one value in its cells
				case 0 : {tmpi = 1;break;}	// do not quantize
				case 1 : {tmpi = 2;break;}	// divide coeffs by tmpi
				case 2 : {tmpi = 5;break;}	// divide coeffs by tmpi
				case 3 : {tmpi = 10;break;}	// divide coeffs by tmpi
				case 4 : {tmpi = 25;break;}	// divide coeffs by tmpi
				case 5 : {tmpi = 50;break;}	// divide coeffs by tmpi
				default : {tmpi = 1;}
			} // end of switch
			
			for (int u=0; u<=7; u++)
			for (int v=0; v<=7; v++)
			{ 	
				l[u][v] = new JLabel(String.valueOf(tmpi),SwingConstants.CENTER);
				l[u][v].setBorder(new SoftBevelBorder(BevelBorder.LOWERED));
				p1.add(l[u][v]);
			}
		
		} // end of else
		
		p2.add(b);
		
		getContentPane().add(p1,"Center");
		getContentPane().add(p2,"South");
		
		setLocation((screenDim.width-250)/2,(screenDim.height-250)/2);		
		setSize(250,250);
		
	}
		
} // end of class
