// TheFrame.java

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.Color.*;
import java.io.*;
import java.net.*;
import java.math.*;

public class TheFrame extends JFrame //implements ActionListener, AdjustmentListener, FocusListener
{	
	URL codebase;
	TheGUI gui; // the Graphical User Interface (GUI)	
		
	GridBagConstraints gbc = new GridBagConstraints();
	Toolkit tk = Toolkit.getDefaultToolkit();
	Dimension preferredFrameDim = new Dimension(800,630);
	Dimension screenDim = tk.getScreenSize();
	Dimension frameDim;
	int screenheight = screenDim.height;
	int screenwidth = screenDim.width;
			
	public TheFrame(URL codebase)	
	{
		this.codebase = codebase;				
		// on ms-windows systems you can close a window with the little x in its top right corner
		// but first you have to activate this option
		addWindowListener(new WindowAdapter()
			{ public void windowClosing(WindowEvent e) { dispose(); TheApplet.activ = false;}});
				
		// sets the standard laf manager
		try{	UIManager.setLookAndFeel("javax.swing.plaf.metal.MetalLookAndFeel");
			SwingUtilities.updateComponentTreeUI(this);
			validate();   }
		catch(Exception e)
		{JOptionPane.showMessageDialog(null,"LookAndFeel switch not successful!\nSwitching to JDK default.","Error",JOptionPane.ERROR_MESSAGE);}
		
		setTitle("2-Dim COSINE Transformation Visualizer");
		setResizable(true);
		
		// standard screensize is stored in 'preferredFrameDim', but if the user's actuall screenresolution
		// is smaller then this, the frame will be only as big as the smaller screensize
		if (screenwidth < preferredFrameDim.width)
		{ 			
			frameDim = new Dimension(screenwidth,screenheight);			
		}
		else    
		{ 					
			frameDim = preferredFrameDim;
			//if the users screenresolution is higher than 800x600 the frame is displayed centered 
			setLocation((screenwidth-preferredFrameDim.width)/2,(screenheight-preferredFrameDim.height)/2);
		}
		
		setSize(frameDim);	
								
		gui = new TheGUI(codebase, this, frameDim); // the GUI
						
	} // end of public Frame Constructor
} // end of class