//m.java is a collection of methods used in the other classes

import javax.swing.*;
import javax.swing.border.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.Color.*;
import java.io.*;


// this is a collection of methods, variables and constants 
class m
{	
	// depending on transformation mode the scrollbars get different maxamplitudes and minamplitudes
	final static int minAmplDCT = -2048; // was -400
	final static int maxAmplDCT = 2048; // was 400
	
	final static String minmaxAmplString = "["+String.valueOf(m.minAmplDCT)+","+String.valueOf(m.maxAmplDCT)+"]";
	
	static String globalfont = "Serif";
	static Font titlefont = new Font(globalfont,Font.BOLD,12);
	static Font font = new Font(globalfont,Font.BOLD,13);
	
	static int[][] StandardJPEGTable = new int[][]
			{
				{ 16, 11, 10, 16, 24, 40, 51, 61},
				{ 12, 12, 14, 19, 26, 58, 60, 55},
				{ 14, 13, 16, 24, 40, 57, 69, 56},
				{ 14, 17, 22, 29, 51, 87, 80, 62},
				{ 18, 22, 37, 56, 68,109,103, 77},
				{ 24, 35, 55, 64, 81,104,113, 92},
				{ 49, 64, 78, 87,103,121,120,101},
				{ 72, 92, 95, 98,112,100,103, 99},
			 };
		
	
//****************************************** addToGBL *******************************************************************
	
	// addToGBL is a very useful method which makes it easy to add a component into a panel	with a 
	// GridBagLayout as LayoutManager
	public static void addToGBL(JPanel p, Component c, GridBagConstraints gbc, 
		int x, int y,	     // coordinate of the components top left corner
		int w, int h,	     // height and width of component (in cells)
		int wx, int wy,      // should component grow with the window (=100) or not (=0) ??
		int filler) 	     // in which direction should component fill empty space ??
				     // 	BOTH(=0),VERTICAL(=1),HORIZONTAL(=2),NONE(=3)
	{			
		gbc.gridx = x;
		gbc.gridy = y;	
		gbc.gridwidth = w;
		gbc.gridheight = h;
		gbc.weightx = wx;
		gbc.weighty = wy;
		switch (filler)
		{
			case 0: { gbc.fill = gbc.BOTH; 		break; } 
			case 1:	{ gbc.fill = gbc.VERTICAL; 	break; } 
			case 2:	{ gbc.fill = gbc.HORIZONTAL; 	break; } 
			case 3: { gbc.fill = gbc.NONE; 		break; }
		} // end switch	
				
		p.add(c, gbc);	
	} // end of public void addToGBL(JPanel p,...
	
	
	// additional insets parameter
	public static void addToGBL(JPanel p, Component c, GridBagConstraints gbc, 
		int x, int y,int w, int h, int wx, int wy, int filler, 	// same as above
		Insets insets)	     // adds space around the component : new Insets(top,left,bottom,right)
	{	
		gbc.insets = insets;
		addToGBL(p,c,gbc,x,y,w,h,wx,wy,filler);		
	} // end of addToBGL with additional insets parameter
	
//****************************************** addToGBL *******************************************************************	
		
	// creats etched, titled borders with a special font; used to give panels a border
	public static TitledBorder titledborder(String bordertitle)
	{
		TitledBorder tb = new TitledBorder(new EtchedBorder(),bordertitle);
		tb.setTitleFont(titlefont);
		return tb;
	} // end of public static TitledBorder tborder(String titletext)


	// this method checks if the a fields input is valid
	public static boolean isValid(String s, int min, int max)
	{			
		String mi = String.valueOf(min);
		String ma = String.valueOf(max);
		String message1 = "Input not in [" + mi + "..." + ma + "] !!";
		String message2 = "YOU HAVE TO PUT IN A NUMBER !!";
		int z = 0;
		
		try
		{
			z = Integer.parseInt(s);
			if ((min <= z) && (z <= max)) 
			{ 
				return true; // number ist valid
			} 
			else 
			{				
				JOptionPane.showMessageDialog(null,message1,"Error",JOptionPane.ERROR_MESSAGE); 
				return false; // number too small / too big
			}	
		} // end of try 
		catch (NumberFormatException exc)
		{ 				
			JOptionPane.showMessageDialog(null,message2,"Error",JOptionPane.ERROR_MESSAGE);
			return false; // not a number
		} // end of catch
			
	} // end of public static boolean isValid(String s, int min, int max)
	
	
	// nothing to say ...
	static int getMinAmpl(String transformationmode)
	{	
		return minAmplDCT;
	}
	
	static int getMaxAmpl(String transformationmode)
	{
		return maxAmplDCT;
	}
	
	static void printMatrix(int[][] m)
	{
		System.out.println("\n *************\n");
		for (int y = 0; y < 8; y++)
	  	  System.out.println(m[y][0]+" "+m[y][1]+" "+m[y][2]+" "+m[y][3]+" "+
 	  			     m[y][4]+" "+m[y][5]+" "+m[y][6]+" "+m[y][7]);	
		System.out.println("\n *************\n");	
	}
		
} // end of class m(ethods)