// menubar.java
import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.util.*;
import javax.swing.*;

public class menuBar extends JMenuBar implements ActionListener {	
	
JMenu programMenu = new JMenu("Program"),
      lafMenu = new JMenu("Look and Feel"),
      solutionMenu = new JMenu("Solution"),
      helpMenu = new JMenu("?");

JMenuItem menuitem;
JRadioButtonMenuItem rbmitem,lafold;
ButtonGroup buttongroup;

String plaf,plafold = "javax.swing.plaf.metal.MetalLookAndFeel";

TheFrame parent;
URL codebase;	
Browser b;
static Vector registeredFrames = new Vector();
			
menuBar(URL codebase, TheFrame parent,TheEventHandler eventhandler)
{	
	this.parent = parent;
	this.codebase = codebase;
	// the 'program' menu has the 'quit' option	
	
	//*********
	buttongroup = new ButtonGroup();
		
	rbmitem = new JRadioButtonMenuItem("Metal (Standard)");
	rbmitem.addActionListener(this);
	lafMenu.add(rbmitem);
	buttongroup.add(rbmitem);
	rbmitem.setSelected(true);
	lafold=rbmitem;
				
	rbmitem = new JRadioButtonMenuItem("Motif");
	rbmitem.addActionListener(this);
	lafMenu.add(rbmitem);
	buttongroup.add(rbmitem);
		
	rbmitem = new JRadioButtonMenuItem("Windows");
	rbmitem.addActionListener(this);
	lafMenu.add(rbmitem);
	buttongroup.add(rbmitem);
		
	rbmitem = new JRadioButtonMenuItem("Macintosh");
	rbmitem.addActionListener(this);
	lafMenu.add(rbmitem);
	buttongroup.add(rbmitem);
		
	rbmitem = new JRadioButtonMenuItem("Organic");
	rbmitem.addActionListener(this);
	lafMenu.add(rbmitem);
	buttongroup.add(rbmitem);
	
	
	//*********
			
	menuitem = new JMenuItem("Quit");
	menuitem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_Q, InputEvent.CTRL_MASK));
	menuitem.addActionListener(this);
	
	programMenu.add(lafMenu);
	programMenu.add(menuitem);				
							
	// the '?' menu has the option 'about'			
	menuitem = new JMenuItem("** MAGIC **");
	menuitem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_M, InputEvent.CTRL_MASK));
	menuitem.addActionListener((ActionListener)eventhandler);
	solutionMenu.add(menuitem);

	menuitem = new JMenuItem("Help");
	menuitem.addActionListener(this);
	helpMenu.add(menuitem);

	menuitem = new JMenuItem("About");
	menuitem.addActionListener(this);
	helpMenu.add(menuitem);
	
	// the menubar itself
	add(programMenu);
	add(solutionMenu);
	add(helpMenu);
			
} // end of constructor 

	
// ************************************** Action Performed *********************************************	
	
public void actionPerformed(ActionEvent evt)
{			
	if (evt.getSource() instanceof JMenuItem)
	{
		Icon messageIcon;
		
		try 
		{				
			messageIcon = new ImageIcon(new URL( codebase , "ich.gif"));
		} catch(MalformedURLException m){ messageIcon = null; }
			
		//URL u = Menubar.class.getResource("ich_72dpi.gif");
		//Icon messageIcon = new ImageIcon(appl.getImage(u));		
		
		String arg = evt.getActionCommand();
			
		if (arg.equals("Quit"))
		{
			parent.dispose();			
		}
		
		if (arg.equals("Help")) browserStarten("html/helpindex.html");
		
		if (arg.equals("About"))
		{	String message;
		
			message = "2-Dim Cosine Transformation Visualizer Version 1.0\n\n"+
				  "Authors : Claudia Schremmer & Holger Wons\n"+				  
				  "\n\n\n\n"+
				  "(c) 2000 University of Mannheim\n "+
				  "Lehrstuhl für Praktische Informatik IV\n"+
				  "http://www.informatik.uni-mannheim.de/informatik/pi4\n"+
				  "http://www.uni-mannheim.de";
			
			JOptionPane.showMessageDialog
				(null,message,"About",JOptionPane.INFORMATION_MESSAGE,messageIcon); 				
		}
	}
	
	if (evt.getSource() instanceof JRadioButtonMenuItem)
		{			
			String arg = evt.getActionCommand();
			JRadioButtonMenuItem rbmi = (JRadioButtonMenuItem)evt.getSource();
			boolean success;
			
			// the reaction to the 'look and feel' submenuentries
			if (arg.equals("Metal (Standard)")) { plaf = "javax.swing.plaf.metal.MetalLookAndFeel"; }
			if (arg.equals("Motif")) { plaf = "com.sun.java.swing.plaf.motif.MotifLookAndFeel"; }
			if (arg.equals("Windows")) { plaf = "com.sun.java.swing.plaf.windows.WindowsLookAndFeel"; }
			if (arg.equals("Macintosh")) { plaf = "com.sun.java.swing.plaf.macintosh.MacintoshLookAndFeel"; }
			if (arg.equals("Organic")) { plaf = "com.sun.java.swing.plaf.organic.OrganicLookAndFeel"; }
			do
			{
				try
				{
					UIManager.setLookAndFeel(plaf);
					SwingUtilities.updateComponentTreeUI(parent);
					validate();
					success = true;
					plafold = plaf;
					lafold = rbmi;
				}
				catch(Exception e)
				{	
					String message = "LookAndFeel switch not successful!\n\n"+
					                 "Maybe that pluggable LaF component is not present\n"+
					                 "in your JDK/PlugIn version.";
					String messagetitle = "ERROR";
					JOptionPane.showMessageDialog(null,message,messagetitle,JOptionPane.ERROR_MESSAGE);
					
					plaf = plafold;
					rbmi = lafold;
					rbmi.setSelected(true);
					success = false;
				}
			} while(!success);// end of while not success
			
		} // end of if (evt.getSource()...	

} // end of public void actionPerformed...

private void browserStarten(final String seite){
		SwingUtilities.invokeLater(new Runnable(){
			public void run(){
				if(b == null){
					b = new Browser(codebase, seite);
					b.setTitle("Help");
					b.setSize(new Dimension(570, 600));
				}
				else
					b.setPage(codebase, seite);
				b.setVisible(true); 
			}
		});
	}
	
public static void registerFrame(JFrame frame){
		registeredFrames.add(frame);
	}
		
} //end of class menubar extends JMenuBar
